/*
 * Performance monitoring library.
 * by D.Michel
 * 100% non portable :)
 */

#ifndef __CLOCK_H_INCLUDED__
#define __CLOCK_H_INCLUDED__

#include <allegro.h>
#include <pc.h>

#define MAX_CLOCKS          10

#define DISABLE()   asm volatile ("cli")
#define ENABLE()    asm volatile ("sti")
#define IO_DELAY()  asm volatile ("jmp 0f; 0:")

/*
 * variables.
 */
typedef struct {
    unsigned int frame;
    unsigned int time;
    unsigned int skip;
    unsigned int min;
    unsigned int max;
    unsigned int average;
    unsigned int total;
    unsigned int start, stop;
    int active;
} Clock_t;

extern Clock_t Clock[MAX_CLOCKS];

/*
 * function prototypes.
 */
void  Clock_Start(int);
void  Clock_Stop(int);
int   Clock_Diff(int, int);
int   Clock_GetTime(void);
char *Clock_GetString(int);
void  Clock_Init(void);
void  Clock_Reset(void);
void  Clock_Exit(void);

#endif /* __CLOCK_H_INCLUDED__ */

