#include "gui.h"
#include "cpu.h"

#define MAX_FRAME_SKIP 8

int Emu_Init(GAME *game);
int Emu_Reset(WINDOW *window, GADGET *d);
int Emu_DoFrame(void);
int Emu_InitAudioSystem(void);
int Emu_LoadROMList(void);
void Emu_CheckKeys(BITMAP *scr);
void Emu_RequestRedraw(void);
void Emu_UpdateAudio(void);
void Emu_Shutdown(void);
void Emu_ShutdownAudioSystem(void);
void Emu_FreeROMList(void);
void EmuWindow_Shutdown(WINDOW *window);
void Emu_Blit(BITMAP *src, BITMAP *dest, int sx, int sy, int dx, int dy, int x_flip, int colourbase);
void Emu_MaskedBlit(BITMAP *src, BITMAP *dest, int sx, int sy, int dx, int dy, int x_flip, int y_flip, int colourbase);
void throttle_timer(void);

void Palette_Recalc(byte *mem);
int Palette_FindColour(int r, int g, int b);

int gui_emu_screen_proc(MSG *msg, WINDOW *window, GADGET *d);
int gui_memdump_proc(MSG *msg, WINDOW *window, GADGET *d);
int gui_palview_proc(MSG *msg, WINDOW *window, GADGET *d);

byte *Emu_LoadRom(char *filename, int expected_size, unsigned int expected_checksum);
void Emu_AddPlane(BITMAP *dest, byte *src, int plane, int tile, int count);

extern GADGET gui_emu_dialog[];

extern WINDOW *emu_window;
extern GAME *current_game;
extern MACHINE *machine;
extern FONT *bios_font;
extern BITMAP *sprites;
extern int palette_map[512];
extern int dirty_map[32][16];
extern int gametic;
extern volatile int timertic;
extern int audio_initialised, sample_rate;
extern int use_vsync, frameskip;
extern int emu_palette_dirty;
extern byte dip_sw_1, dip_sw_2;

extern int key_left, key_right, key_up, key_down, key_b1, key_b2;
extern int key_start1, key_start2, key_coin;
