#include "gui.h"
#include "emu.h"

//#define INSECTOR_X
#define VERSION_STRING "v2.21"
#define LOG_FILENAME "debug.txt"

typedef struct {
   int x, y, x2, y2;
   char name[100];
} HELP_LINK;

extern GADGET gui_toolbar_dialog[];
extern GADGET gui_help_dialog[];
extern WINDOW *help_window;
extern int use_scanlines;
extern FONT *bigfont, *verybigfont;
extern int num_help_links;
extern HELP_LINK help_links[10];

int Main_Startup(void);
int Main_ChangeGame(WINDOW *window, GADGET *d);
int Main_ChangeGameCallback(WINDOW *window, GADGET *d);
void Main_StartGame(GAME *game);
int Main_Fullscreen(WINDOW *window, GADGET *d);
int Main_Help(WINDOW *window, GADGET *d);
int Main_Quit(WINDOW *window, GADGET *d);
int Main_Shutdown(WINDOW *window, GADGET *d);
void Main_CloseToolbar(WINDOW *window);

char *Help_FindLink(char *name);
int Help_PrintLine(BITMAP *bmp, char *text, int x, int y, int section_header);
void Help_Shutdown(WINDOW *window);

int Emu_Options(WINDOW *window, GADGET *d);
int Options_UpdateSettings(WINDOW *window, GADGET *d);
void Options_Shutdown(WINDOW *window);
int Emu_Debugging(WINDOW *window, GADGET *d);
int Debugging_UpdateSettings(WINDOW *window, GADGET *d);
void Debugging_Shutdown(WINDOW *window);

extern WINDOW *gamelist_window;
extern GADGET gui_gamelist_dialog[];
void Gamelist_RunGame(char *name);
void Gamelist_Shutdown(WINDOW *window);
int gui_gamelist_proc(MSG *msg, WINDOW *window, GADGET *d);
