#include <string.h>
#include "nz.h"

extern GAME insector_driver;
extern GAME tnzs_driver;
extern GAME tnzs_alt_driver;
extern GAME tnzs_new_driver;

GAME *gamelist[] = {
#ifdef INSECTOR_X
   &insector_driver,
#endif
   &tnzs_driver,
   &tnzs_alt_driver,
   &tnzs_new_driver,
   NULL
};

WINDOW *gamelist_window=NULL;

GADGET gui_gamelist_dialog[] = {
   /* (dialog proc)     (x)          (y)       (w)       (h)           (flags)  (d1) (d2)  (dp) [dp2] */
   { gui_window_proc,   0,           0,        NC_W+200, NC_H+100,     0,       0,   0,    "Choose a game:" },
   { gui_closebox_proc, NC_W+200-12, 2,        9,        9,            D_EXIT,  0,   0,    NULL },
   { gui_gamelist_proc, NC_X,        NC_Y,     200,      100,          0,       0,   0,    &Main_StartGame },
   { NULL }
};

void Gamelist_RunGame(char *name)
{
   GAME **game;
   game = &gamelist[0];
   while(*game)
   {
      if (stricmp((*game)->short_name, name) == 0)
      {
         Main_StartGame(*game);
         if (current_game) Main_Fullscreen(NULL, NULL);
         return;
      }
      game++;
   }
   GUI_PrintLog(TRUE, "Game '%s' not found!", name);
   GUI_MessageBox(MB_OK, NULL, "Game '%s' not found!", name);
}

void Gamelist_Shutdown(WINDOW *window)
{
   if (window)
   {
      set_config_int("Gamelist_window", "x_position", window->x);
      set_config_int("Gamelist_window", "y_position", window->y);
   }
   gamelist_window = NULL;
}

int gui_gamelist_proc(MSG *msg, WINDOW *window, GADGET *d)
{
   int y, y2;
   GAME **game;
   switch(msg->type)
   {
   case MSG_CLICK:
      game = &gamelist[0];
      y = 0;
      while(*game)
      {
         y2 = y + text_height(font);
         if (msg->y >= y && msg->y < y2)
         {
            Main_StartGame(*game);
            return D_CLOSE;
         }
         y = y2;
         game++;
      }
      return D_O_K;
   case MSG_DRAW:
      rectfill(d->bmp, 0, 0, d->w-1, d->h-1, GUI_WHITE);

      text_mode(GUI_WHITE);
      game = &gamelist[0];
      y = 0;
      while(*game)
      {
         textout(d->bmp, font, (*game)->long_name, 1, y, GUI_BLACK);
         y += text_height(font);
         game++;
      }
      return D_O_K;
   }
   return D_O_K;
}
